#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const yargs_1 = __importDefault(require("yargs"));
const helpers_1 = require("yargs/helpers");
const fs = __importStar(require("fs"));
const compiler_1 = require("./parser/compiler");
const path_1 = __importDefault(require("path"));
(0, yargs_1.default)((0, helpers_1.hideBin)(process.argv))
    .usage("Logimat compiler")
    .command("$0 <file>", "Compile a Logimat file.", {
    latex: {
        alias: "l",
        default: false,
        type: "boolean",
        describe: "Output the compiled expression(s) in LaTeX form (good for rendering images)."
    },
    nofs: {
        alias: "n",
        default: false,
        type: "boolean",
        describe: "Blocks untrusted filesystem operations (for example, code telling the compiler to load an NPM module). This is not a security feature."
    },
    piecewise: {
        alias: "p",
        default: false,
        type: "boolean",
        describe: "Compiles using piecewise instead of raw math. This can improve performance and readability in Desmos."
    },
    strict: {
        alias: "s",
        default: false,
        type: "boolean",
        describe: "Throws an error if any undefined functions or variables are used."
    }
}, (args) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        const file = args.file;
        if (!fs.existsSync(file))
            return console.error("Error: The specified file does not exist!");
        fs.accessSync(file, fs.constants.R_OK);
        const data = fs.readFileSync(file, "utf-8");
        const compiled = yield (0, compiler_1.Compile)(data, args.latex, args.nofs, path_1.default.resolve(file), args.piecewise, args.strict);
        if (typeof (compiled) === "string")
            process.stdout.write(compiled);
        else
            process.stdout.write(JSON.stringify(compiled));
    }
    catch (e) {
        process.stderr.write(e.stack);
    }
}))
    .showHelpOnFail(true)
    .help()
    .demandCommand()
    .argv;
//# sourceMappingURL=bin.js.map