export declare type TemplateArg = string | number | boolean | TemplateBlock;
export declare type TemplateArgs = TemplateArg[];
export declare type TemplateReturn = string | ((state: object) => TemplateReturn);
export declare type TemplateFunction = (args: TemplateArgs, state: TemplateState, context: TemplateContext) => TemplateReturn | Promise<TemplateReturn>;
export interface TemplateState {
}
export declare enum TemplateContext {
    OuterDeclaration = 0,
    InnerDeclaration = 1,
    Expression = 2
}
export interface TemplatesObject {
    [key: string]: TemplateObject;
}
export interface TemplateObject {
    function: TemplateFunction;
}
export interface TemplateModule {
    templates: TemplateObject;
    postTemplates?: string;
}
export interface TemplateBlock {
    block: true;
    value: string;
}
export interface LogimatTemplateState {
    logimat: {
        files: string[];
        definitions: Record<string, TemplateArg>;
    };
}
