declare const _default: "//Returns on 0 on 0, and 1 for anything else.\ninline function select(a) {\n    const p1 = 2^(-abs(a));\n    const p2 = not(p1);\n    \n    ceil(p2)\n}\n\n//A more efficient representation of not(select(a)).\ninline function notSelect(a) {\n    const p1 = 2^(-abs(a));\n    \n    floor(p1)\n}\n\n//Returns 1 if both inputs are 1, otherwise 0.\n//\n//Because the set of inputs is limited, this is a simple function that satisfies them,\n//but has other behavior on undefined inputs.\ninline function and(a, b) => a * b;\n\n//Returns 0 if both inputs are 0, otherwise 1.\n//\n//Because the set of inputs is limited, this is a simple function that satisfies them,\n//but has other behavior on undefined inputs.\ninline function or(a, b) => ceil((a + b)/2);\n\n//Returns 0 on 1, and 1 on 0.\n//\n//Because the set of inputs is limited, this is a simple function that satisfies them,\n//but has other behavior on undefined inputs.\ninline function not(a) => 1 - a;\n\n//Returns 0 if a is 1 and b is 1.\n//\n//Because the set of inputs is limited, this is a simple function that satisfies them,\n//but has other behavior on undefined inputs.\ninline function nand(a, b) => not(and(a, b));\n\n//Returns 1 if a is 0 and b is 0.\n//\n//Because the set of inputs is limited, this is a simple function that satisfies them,\n//but has other behavior on undefined inputs.\ninline function nor(a, b) => not(or(a, b));\n\n//Returns 1 if both inputs are different.\n//\n//Because the set of inputs is limited, this is a simple function that satisfies them,\n//but has other behavior on undefined inputs.\ninline function xor(a, b) => abs(a - b);\n\n//Returns 1 if both inputs are the same.\n//\n//Because the set of inputs is limited, this is a simple function that satisfies them,\n//but has other behavior on undefined inputs.\ninline function xnor(a, b) => not(xor(a, b));\n\n//Returns 1 when both inputs are the same, and zero otherwise.\n//\n//Essentially, this works because two numbers being subtracted will be zero if they are\n//the same. The select function can then be used to turn all non-zeros to one, and\n//the not turns one to zero and zero to one, so the output is in the correct format.\ninline function equal(a, b) => notSelect(a - b);\n\n//A more efficient representation of not(equal(a, b)).\ninline function notEqual(a, b) => select(a - b);\n\n//Returns a > 0.\ninline function isPositive(a) {\n    const p1 = 2^a;\n    const p2 = p1^-1;\n    const p3 = floor(p2)+1;\n    const p4 = p3^-1;\n\n    floor(p4)\n}\n\n//Returns a >= 0.\ninline function isPositiveOrZero(a) => isPositive(a+1);\n\n//Returns a < 0.\ninline function isNegative(a) => isPositive(-a);\n\n//Returns a <= 0;\ninline function isNegativeOrZero(a) => not(isPositive(a));\n\n//Returns 1 if the first input is smaller than the second, and zero otherwise.\n//\n//Essentially, this works because if b is larger than a, their difference will\n//become negative. This is tested using isNegative.\ninline function lt(a, b) => isNegative(a-b);\n\n//Returns 1 if the first input is smaller than the second or they are equal, and zero otherwise.\ninline function lte(a, b) => isNegativeOrZero(a-b);\n\n//Returns 1 if the first input is larger than the second, and zero otherwise.\ninline function gt(a, b) => lt(b, a);\n\n//Returns 1 if the first input is larger than the second or they are equal, and zero otherwise.\ninline function gte(a, b) => lte(b, a);\n\n//Returns b if a is 1, and c if a is 0.\ninline function if_func(a, b, c) => a*b + not(a)*c;\n\n//Returns the smallest number.\ninline function min(a, b) {\n    if(a < b) {\n        a\n    } else {\n        b\n    }\n}\n\n//Returns the biggest number.\ninline function max(a, b) {\n    if(a > b) {\n        a\n    } else {\n        b\n    }\n}\n\n//Rounds a number.\ninline function round(a) => floor(a + .5);";
export default _default;
