declare const _default: "//Returns 1 if the input is prime, and 0 otherwise.\n//Accepts integers greater or equal to zero.\n//\n//All this function does is loop through every number < floor(sqrt(a)), then checks if a is divisible by it.\n//If it is, then it adds 1 to the sum, otherwise zero. This is then put through select, which will make it 0\n//if prime and 1 otherwise. Next, it's put through not, to make it the opposite.\ninline function isPrime(a) {\n    const p1 = sum(n=2; floor(sqrt(a))) {\n        if(floor(a/n) == a/n) {\n            1\n        } else {\n            0\n        }\n    };\n\n    notSelect(p1)\n}\n\n//Returns the number of digits in the input.\ninline function len(a){\n    const val = abs(a);\n\n    if(val < .1) {\n        0\n    } else {\n        floor(log(val)) + 1\n    }\n}\n\n//Safely returns the number of digits in the input.\ninline function safeLen(a){\n    const val = abs(a);\n\n    if(val < .1) {\n        0\n    } else {\n        floor(safeLog(val)) + 1\n    }\n}\n\n//Extracts the nth digit (starting at 0) from a number. The first input is the number and the second is the place of the digit.\ninline function getDigit(a, b) {\n    const pt1 = a/10^(len(a)-b-1);\n    const pt2 = a/10^(len(a)-b);\n    \n    floor(pt1-floor(pt2)*10)\n}\n\n//Safely extracts the nth digit (starting at 0) from a number. The first input is the number and the second is the place of the digit.\ninline function safeGetDigit(a, b) {\n    const pt1 = a/10^(safeLen(a)-b-1);\n    const pt2 = a/10^(safeLen(a)-b);\n    \n    floor(pt1-floor(pt2)*10)\n}\n\n//Returns the number of digits in the input in a specific base.\ninline function lenBase(a, base){\n    const val = abs(a);\n\n    if(val < base^-1) {\n        0\n    } else {\n        floor(log_base(val)) + 1\n    }\n}\n\n//Safely returns the number of digits in the input in a specific base.\ninline function safeLenBase(a, base){\n    const val = abs(a);\n\n    if(val < base^-1) {\n        0\n    } else {\n        floor(safeLogBase(val, base)) + 1\n    }\n}\n\n//Extracts the nth digit (starting at 0) from a number in a specific base. The first input is the number and the second is the place of the digit.\ninline function getDigitBase(a, b, base) {\n    const pt1 = a/base^(lenBase(a, base)-b-1);\n    const pt2 = a/base^(lenBase(a, base)-b);\n    \n    floor(pt1-floor(pt2)*base)\n}\n\n//Safely extracts the nth digit (starting at 0) from a number in a specific base. The first input is the number and the second is the place of the digit.\ninline function safeGetDigitBase(a, b, base) {\n    const pt1 = a/base^(safeLenBase(a, base)-b-1);\n    const pt2 = a/base^(safeLenBase(a, base)-b);\n    \n    floor(pt1-floor(pt2)*base)\n}\n\n//Returns 1 if the input is an integer, and 0 otherwise.\ninline function isInt(a) => a == floor(a);\n\n//Returns if the dividend can be evenly divided by the divisor.\ninline function isDivisibleBy(dividend, divisor) => dividend % divisor == 0;\n\n//Safely divides a number (a/b), such that if b is 0 (a/0), it will return 0 instead of undefined.\n//Normally, if you divide a number by 0 (even if inside a statement that doesn't run) it will return\n//undefined for the entire function. This solves that issue. Use this anywhere that the divisor may\n//be 0.\ninline function safeDivide(a, b) {\n    if(b == 0) {\n        0\n    } else {\n        //This double check is needed because it will run, and needs to divide by a non-zero number. 1 is a \"safe\" value, but it's being used arbitrarily here.\n        //No matter what number is used, it won't ever appear, unless it results in undefined (which will only happen if the value is 0 or infinity).\n        const num = if(b == 0) {\n            1\n        } else {\n            b\n        };\n        \n        a/num\n    }\n}\n\n//Safely runs the log function, returning 0 if the input is 0.\ninline function safeLog(a) {\n    if(a == 0) {\n        0\n    } else {\n        const val = if(a == 0) {\n            1\n        } else {\n            a\n        };\n        \n        log(val)\n    }\n}\n\n//Safely runs the ln function, returning 0 if the input is 0.\ninline function safeLN(a) {\n    if(a == 0) {\n        0\n    } else {\n        const val = if(a == 0) {\n            1\n        } else {\n            a\n        };\n        \n        ln(val)\n    }\n}\n\n//Gets the log for a certain base.\n//Deprecated in favor of log_ syntax.\ninline function logBase(num, base) => log_base(num);\n\n//Safely gets the log for a certain base, returning 0 if the input is 0.\ninline function safeLogBase(num, base) {\n    if(base == 0) {\n        0\n    } else {\n        const base = if(base == 0) {\n            1\n        } else {\n            base\n        };\n        \n        log_base(num)\n    }\n}\n\n//Simplifies a fraction and returns the numerator.\ninline function simplifyNumerator(numerator, denominator) {\n    const factor = gcd(numerator, denominator);\n    numerator/factor\n}\n\n//Simplifies a fraction and returns the denominator.\ninline function simplifyDenominator(numerator, denominator) {\n    const factor = gcd(numerator, denominator);\n    denominator/factor\n}\n\n//Gets the real part of a complex number.\ninline function cR(a) => a.x;\n\n//Gets the imaginary part of a complex number.\ninline function cI(a) => a.y;\n\n//Takes the absolute value of a complex number.\ninline function cAbs(a) => distance(a, (0, 0));\n\n//Calculates the complex argument of a number.\ninline function cArg(a) => mod(arctan(cI(a), cR(a)), 2*pi);\n\n//Multiplies two complex numbers together.\n//https://en.wikipedia.org/wiki/Multiplication_algorithm#Complex_multiplication_algorithm\ninline function cMul(a, b) {\n    const aPart1 = cR(a) * cR(b);\n    const aPart2 = cI(a) * cI(b);\n    const aPart = aPart1 - aPart2;\n    \n    const bPart1 = cI(a) * cR(b);\n    const bPart2 = cR(a) * cI(b);\n    const bPart = bPart1 + bPart2;\n    \n    (aPart, bPart)\n}\n\n//Divides two complex numbers.\n//https://mathworld.wolfram.com/ComplexDivision.html\ninline function cDiv(a, b) {\n    const aPart1 = cR(a) * cR(b);\n    const aPart2 = cI(a) * cI(b);\n    const aPart = aPart1 + aPart2;\n    \n    const bPart1 = cI(a) * cR(b);\n    const bPart2 = cR(a) * cI(b);\n    const bPart = bPart1 - bPart2;\n    \n    const cPart = cR(b)^2 + cI(b)^2;\n    \n    (aPart/cPart, bPart/cPart)\n}\n\n//Adds two complex numbers.\ninline function cAdd(a, b) => a + b;\n\n//Subtracts two complex numbers.\ninline function cSub(a, b) => a - b;\n\n//Raises a real number to a complex power.\ninline function cPowRC(real, complex) {\n    const p1 = cos(cI(complex));\n    const p2 = sin(cI(complex));\n    \n    const mul = (real^cR(complex), 0);\n    \n    cMul(mul, ln(real) * (p1, p2))\n}\n\n//Raises a complex number to a real power.\ninline function cPowCR(complex, real) {\n    const r = cAbs(complex);\n    const theta = arctan(cI(complex)/cR(complex));\n    \n    const mul = r^real;\n    \n    const p1 = mul*cos(real*theta);\n    const p2 = mul*sin(real*theta);\n    \n    (p1, p2)\n}\n\n//Calculates a complex number to a complex power.\ninline function cPow(base, power) {\n    cExp(cMul(power, cLn(base)))\n}\n\n//Calculates the log of a complex number in a complex base.\ninline function cLog(base, power) {\n    cDiv(cLn(power), cLn(base))\n}\n\n//Raises e to a complex power.\ninline function cExp(a) {\n    e^cR(a) * (cos(cI(a)), sin(cR(a)))\n}\n\n//Calculates the complex natural logarithm of a number.\ninline function cLn(a) {\n    const p1 = ln(cAbs(a));\n    const p2 = cArg(a);\n    \n    (p1, p2)\n}\n\n//Creates a complex number from polar form.\ninline function cPolar(abs, arg) {\n    abs * (cos(arg), sin(arg))\n}\n\n//The complex sine function.\ninline function cSin(a) {\n    const p1 = sin(cR(a)) * cosh(cI(a));\n    const p2 = cos(cR(a)) * sinh(cI(a));\n    \n    (p1, p2)\n}\n\n//The complex cosine function.\ninline function cCos(a) {\n    const p1 = cos(cR(a)) * cosh(cI(a));\n    const p2 = sin(cR(a)) * sinh(cI(a));\n    \n    (p1, -p2)\n}\n\n//The complex tangent function.\ninline function cTan(a) => cDiv(cSin(a), cCos(a));\n\n//The complex cotangent function.\ninline function cCot(a) => cDiv(cCos(a), cSin(a));\n\n//The complex hyperbolic sine function.\ninline function cSinh(a) {\n    const p1 = sinh(cR(a))*cos(cI(a));\n    const p2 = cosh(cR(a))*sin(cI(a));\n    \n    (p1, p2)\n}\n\n//The complex hyperbolic cosine function.\ninline function cCosh(a) {\n    const p1 = cosh(cR(a))*cos(cI(a));\n    const p2 = sinh(cR(a))*sin(cI(a));\n    \n    (p1, p2)\n}\n\n//The complex hyperbolic tangent function.\ninline function cTanh(a) => cDiv(cSinh(a), cCosh(a));\n\n//The complex hyperbolic cotangent function.\ninline function cCoth(a) => cDiv(cCosh(a), cSinh(a));\n\n//Calculates the complex a mod b.\ninline function cMod(a, b) {\n    const p1 = cFloor(cDiv(a, b));\n    const p2 = cMul(p1, b);\n    \n    a - p2\n}\n\n//Applies the floor function to both parts of a complex number.\ninline function cFloor(a) {\n    (floor(cR(a)), floor(cI(a)))\n}\n\n//Applies the ceil function to both parts of a complex number.\ninline function cCeil(a) {\n    (ceil(cR(a)), ceil(cI(a)))\n}\n\n//Applies the round function to both parts of a complex number.\ninline function cRound(a) {\n    (round(cR(a)), round(cI(a)))\n}\n\n//Checks if a number is NaN.\ninline function isNaN(a) => a != a;\n\n//Gets the x position (0-based) of a 2d array embedded in a 1d array (1-based).\n//Used to convert from a 1d array to a 2d array.\ninline function conv_1d_2d_x(idx, width) => (idx-1) % width;\n\n//Gets the y position (0-based) of a 2d array embedded in a 1d array (1-based).\n//Used to convert from a 1d array to a 2d array.\ninline function conv_1d_2d_y(idx, width) => floor((idx-1) / width);\n\n//Gets the index (1-based) of a 1d array from the position x and y of a 2d array (0-based).\n//Used to convert from a 2d array to a 1d array.\ninline function conv_2d_1d(x, y, width) => y * width + x + 1;\n\n//Maps from one range of numbers to another.\ninline function map(input_start, input_end, output_start, output_end, val) {\n    const slope = (output_end - output_start) / (input_end - input_start);\n    \n    output_start + slope * (val - input_start)\n}\n\n//Linearly interpolates from one number to another. This is used to smoothly transition between two numbers.\n//An amount of 0 will return from, 1 will return to, and anything in between will return something\n//between the two numbers.\ninline function lerp(from, to, amount) => from + (to - from) * amount;\n\n//Stores a float and an integer into a single float. Digits defines the precision, and\n//should be at least as many digits that exist in the largest number.\ninline function pack(float, integer, digits) {\n    const half = (10^digits) / 2;\n    \n    (float + half) + (integer + half)*(10^digits)\n}\n\n//Extracts the float part from a packed number.\ninline function unpackFloat(packed, digits) {\n    const half = (10^digits) / 2;\n    \n    mod(packed, 10^digits) - half\n}\n\n//Extracts the int part from a packed number.\ninline function unpackInt(packed, digits) {\n    const half = (10^digits) / 2;\n    \n    floor(packed / 10^digits) - half\n}\n\n//Rounds a number to the closest product of another number. For example, roundTo(1.2, .5) will give 1.\ninline function roundTo(num, to) => to * round(num/to);";
export default _default;
